Package de.willuhn.jameica.hbci.server

# Class TurnusHelper

java.lang.Object
de.willuhn.jameica.hbci.server.TurnusHelper

public class TurnusHelper extends Object
Hilfsklasse fuer das Finden oder Erstellen von Zahlungs-Turnus(sen) ;).

## Constructor Summary

Constructors
Constructor
Description
`TurnusHelper()`

## Method Summary

Modifier and Type
Method
Description
`static String`
`createBezeichnung(Turnus turnus)`
Kleine Hilfs-Funktion, die sich eine passende Bezeichnung fuer einen Turnus selbst ausdenkt ;).
`static Turnus`
`createByDauerAuftrag(org.kapott.hbci.GV_Result.GVRDauerList.Dauer d)`
Erstellt einen neuen Turnus mit den Eigenschaften des uebergebenen Dauerauftrags aus HBCI4Java und speichert ihn auch gleich in der Datenbank.
`static Turnus`
`findByDauerAuftrag(org.kapott.hbci.GV_Result.GVRDauerList.Dauer d)`
Prueft, ob es in der lokalen Datenbank einen Zahlungsturnus gibt, der den Eigenschaften des uebergebenen Dauerauftrags aus HBCI4Java entspricht.
`static Date`
`getNaechsteZahlung(Date ersteZahlung, Date letzteZahlung, Turnus turnus, Date valuta)`
Berechnet das naechste Ausfuehrungsdatum fuer einen Turnus.
`static String`
`getWochentag(int index)`
Liefert die Bezeichnung des Werktages mit dem genannten Index.
`static String[]`
`getWochentage()`
Liefert ein String-Array mit den Bezeichnungen der Wochentage.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### TurnusHelper

public TurnusHelper()

## Method Details

### getWochentage

public static String[] getWochentage()
Liefert ein String-Array mit den Bezeichnungen der Wochentage. Hinweis: Da es sich um ein Array handelt, zaehlt der Index natuerlich nicht von 1-7 sondern von 0-6.

Returns:
  Bezeichnungen der Wochentage.

### getWochentag

public static String getWochentag(int index)
Liefert die Bezeichnung des Werktages mit dem genannten Index. Den zum Zahltag des Turnus gehoerenden kann man dann wie folgt ermitteln:
`String tag = TurnusHelper.getWochentag(turnus.getTag())`.

Parameters:
  `index` - Index des Wochentages von 1 - 7.
Returns:
  Bezeichnung des Wochentages, oder `null` wenn der Index ausserhalb des definierten Bereichs liegt.

### getNaechsteZahlung

public static Date getNaechsteZahlung(Date ersteZahlung, Date letzteZahlung, Turnus turnus, Date valuta) throws RemoteException
Berechnet das naechste Ausfuehrungsdatum fuer einen Turnus.

Parameters:
  `ersteZahlung` - Datum der ersten Zahlung.
  `letzteZahlung` - Datum der letzten Zahlung.
  `turnus` - Turnus.
  `valuta` - Stichtag, zu dem die Berechnung erfolgen soll. Ist kein Datum angegeben, wird das aktuelle verwendet.
Returns:
  das ermittelte Datum oder `null`, wenn keines mehr existiert.
Throws:
  `RemoteException`

### findByDauerAuftrag

public static Turnus findByDauerAuftrag(org.kapott.hbci.GV_Result.GVRDauerList.Dauer d) throws RemoteException
Prueft, ob es in der lokalen Datenbank einen Zahlungsturnus gibt, der den Eigenschaften des uebergebenen Dauerauftrags aus HBCI4Java entspricht.

Parameters:
  `d` - der zu pruefende Dauerauftrag.
Returns:
  das Turnus-Objekt, wenn eines gefunden wurde oder `null`.
Throws:
  `RemoteException`

### createByDauerAuftrag

public static Turnus createByDauerAuftrag(org.kapott.hbci.GV_Result.GVRDauerList.Dauer d) throws RemoteException, de.willuhn.util.ApplicationException
Erstellt einen neuen Turnus mit den Eigenschaften des uebergebenen Dauerauftrags aus HBCI4Java und speichert ihn auch gleich in der Datenbank. Wichtig: Die Funktion checkt bereits intern mittels `findByDauerAuftrag` ob bereits einer existiert und liefert ggf diesen zurueck. Der Aufrufer muss also nicht selbst pruefen, ob einer existiert.

Parameters:
  `d` - der zu pruefende Dauerauftrag.
Returns:
  das Turnus-Objekt. Es wird in jedem Fall ein solches zurueckgegeben. Das ist entweder ein neues oder ein existierendes.
Throws:
  `RemoteException`
  `de.willuhn.util.ApplicationException`

### createBezeichnung

public static String createBezeichnung(Turnus turnus) throws RemoteException
Kleine Hilfs-Funktion, die sich eine passende Bezeichnung fuer einen Turnus selbst ausdenkt ;).

Parameters:
  `turnus` - der Turnus, fuer den eine Bezeichnung erstellt werden soll.
Returns:
  die Bezeichnung.
Throws:
  `RemoteException`